#import "AppDelegate.h"
#import "IACManager.h"

@interface AppDelegate ()
@end

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application
    didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {

    self.log = @"";
    self.log = [self.log stringByAppendingString:@"Test App "];
    self.log =
        [self.log stringByAppendingString:[[NSBundle mainBundle] infoDictionary]
                                              [@"CFBundleShortVersionString"]];
    self.log = [self.log stringByAppendingString:@"\n"];

    [IACManager sharedManager].callbackURLScheme = [[[NSBundle mainBundle]
        infoDictionary] objectForKey:@"CFBundleIdentifier"];
    [self addAPIHandlers];

    [[UITabBar appearance] setTintColor:[UIColor yellowColor]];
    [[UITabBar appearance] setUnselectedItemTintColor:[UIColor whiteColor]];
    [[UITabBar appearance] setBarTintColor:[UIColor systemBlueColor]];
    [[UITabBar appearance] setBackgroundColor:[UIColor systemBlueColor]];

    if (@available(iOS 15, *)) {
        NSDictionary *attributes = @{
            NSFontAttributeName : [UIFont fontWithName:@"HelveticaNeue" size:19.0f],
            NSForegroundColorAttributeName : UIColor.whiteColor
        };

        NSDictionary *barButtonItemAttributes = @{
            NSForegroundColorAttributeName : UIColor.whiteColor
        };

        UINavigationBarAppearance *appearance = [UINavigationBarAppearance new];
        [appearance configureWithOpaqueBackground];
        appearance.titleTextAttributes = attributes;
        appearance.backgroundColor = UIColor.systemBlueColor;

        UIBarButtonItemAppearance *buttonAppearance = [UIBarButtonItemAppearance new];
        buttonAppearance.normal.titleTextAttributes = barButtonItemAttributes;
        appearance.buttonAppearance = buttonAppearance;

        UINavigationBar.appearance.standardAppearance = appearance;
        UINavigationBar.appearance.scrollEdgeAppearance = appearance;
        UINavigationBar.appearance.standardAppearance.buttonAppearance = buttonAppearance;
        UINavigationBar.appearance.standardAppearance.backButtonAppearance = buttonAppearance;
        UINavigationBar.appearance.standardAppearance.doneButtonAppearance = buttonAppearance;
    } else {
        NSDictionary *attributes = @{
            NSFontAttributeName : [UIFont fontWithName:@"HelveticaNeue" size:19.0f],
            NSForegroundColorAttributeName : UIColor.whiteColor
        };
        [[UINavigationBar appearance] setTitleTextAttributes:attributes];
        [[UINavigationBar appearance] setTintColor:[UIColor whiteColor]];
        [[UINavigationBar appearance] setBarTintColor:[UIColor systemBlueColor]];
        [[UINavigationBar appearance] setBackgroundColor:[UIColor systemBlueColor]];
    }

    return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application {
}

- (void)applicationDidEnterBackground:(UIApplication *)application {
}

- (void)applicationWillEnterForeground:(UIApplication *)application {
}

- (void)applicationDidBecomeActive:(UIApplication *)application {
}

- (void)applicationWillTerminate:(UIApplication *)application {
}

- (BOOL)application:(UIApplication *)app
            openURL:(NSURL *)url
            options:(NSDictionary<UIApplicationOpenURLOptionsKey, id> *)option {
    AppDelegate *delegate =
        (AppDelegate *)[[UIApplication sharedApplication] delegate];
    delegate.log = [delegate.log stringByAppendingString:@"callback\n"];
    delegate.log = [delegate.log stringByAppendingString:[url absoluteString]];
    delegate.log = [delegate.log stringByAppendingString:@"\n"];

    return [[IACManager sharedManager] handleOpenURL:url];
}

- (void)addAPIHandlers {
}

@end
