#import "AppDelegate.h"
#import "IACClient.h"
#import "PaymentViewController.h"

@interface PaymentViewController ()
@end

@implementation PaymentViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    self.navigationController.toolbar.translucent = NO;
    self.navigationController.navigationBar.translucent = NO;

    self.textAmount.text = @"";
    self.textDescription.text = @"";
    self.textTransaction.text = @"";
    self.textInput.text = @"1";
    self.textComplete.text = @"1";
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    [self.view.subviews
        enumerateObjectsUsingBlock:^(UIView *obj, NSUInteger idx, BOOL *stop) {
          if ([obj isKindOfClass:[UITextField class]]) {
              [obj resignFirstResponder];
          }
        }];
}

- (IBAction)onPayment:(id)sender {
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    if (self.swAmount.on) {
        [dic setObject:self.textAmount.text forKey:@"amount"];
    }
    if (self.swDescription.on) {
        [dic setObject:self.textDescription.text forKey:@"description"];
    }
    if (self.swTransaction.on) {
        [dic setObject:self.textTransaction.text forKey:@"originalOrderId"];
    }
    if (self.swInput.on) {
        [dic setObject:self.textInput.text forKey:@"inputAmountView"];
    }
    if (self.swComplete.on) {
        [dic setObject:self.textComplete.text forKey:@"completeView"];
    }
    if (self.swMiles.on) {
        [dic setObject:self.textMiles.text forKey:@"miles"];
    }
    if (self.swTimesMiles.on) {
        [dic setObject:self.textTimesMiles.text forKey:@"timesMiles"];
    }

    IACClient *client =
        [IACClient clientWithURLScheme:[[[NSBundle mainBundle] infoDictionary]
                                           objectForKey:@"TARGET_SCHEME"]];
    [client performAction:@"payment"
        parameters:dic
        onSuccess:^(NSDictionary *resultParams) {
          NSString *title = @"payment success";
          if (resultParams == nil) {
              title = @"payment cancel";
          }
          NSString *msg = @"";
          for (id key in [resultParams keyEnumerator]) {
              msg = [msg stringByAppendingString:key];
              msg = [msg stringByAppendingString:@"="];
              msg =
                  [msg stringByAppendingString:[resultParams valueForKey:key]];
              msg = [msg stringByAppendingString:@"\n"];
          }
          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:title
                               message:msg
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }
        onFailure:^(NSError *error) {
          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:@"payment failure"
                               message:[error localizedDescription]
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }];
}

@end
