#import "AppDelegate.h"
#import "IACClient.h"
#import "RefundViewController.h"

@interface RefundViewController ()
@end

@implementation RefundViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    self.navigationController.toolbar.translucent = NO;
    self.navigationController.navigationBar.translucent = NO;
    self.textOrder.text = @"";
    self.textTransaction.text = @"";
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
    [self.view.subviews
        enumerateObjectsUsingBlock:^(UIView *obj, NSUInteger idx, BOOL *stop) {
          if ([obj isKindOfClass:[UITextField class]]) {
              [obj resignFirstResponder];
          }
        }];
}

- (IBAction)onRefund:(id)sender {
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    if (self.swOrder.on) {
        [dic setObject:self.textOrder.text forKey:@"orderId"];
    }
    if (self.swTransaction.on) {
        [dic setObject:self.textTransaction.text forKey:@"originalOrderId"];
    }

    IACClient *client =
        [IACClient clientWithURLScheme:[[[NSBundle mainBundle] infoDictionary]
                                           objectForKey:@"TARGET_SCHEME"]];
    [client performAction:@"refund"
        parameters:dic
        onSuccess:^(NSDictionary *resultParams) {
          NSString *title = @"refund success";
          if (resultParams == nil) {
              title = @"refund cancel";
          }
          NSString *msg = @"";
          for (id key in [resultParams keyEnumerator]) {
              msg = [msg stringByAppendingString:key];
              msg = [msg stringByAppendingString:@"="];
              msg =
                  [msg stringByAppendingString:[resultParams valueForKey:key]];
              msg = [msg stringByAppendingString:@"\n"];
          }

          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:title
                               message:msg
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }
        onFailure:^(NSError *error) {
          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:@"refund failure"
                               message:[error localizedDescription]
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }];
}

- (IBAction)onCancel:(id)sender {
    NSMutableDictionary *dic = [NSMutableDictionary dictionary];
    if (self.swOrder.on) {
        [dic setObject:self.textOrder.text forKey:@"orderId"];
    }
    if (self.swTransaction.on) {
        [dic setObject:self.textTransaction.text forKey:@"originalOrderId"];
    }

    IACClient *client =
        [IACClient clientWithURLScheme:[[[NSBundle mainBundle] infoDictionary]
                                           objectForKey:@"TARGET_SCHEME"]];
    [client performAction:@"cancel"
        parameters:dic
        onSuccess:^(NSDictionary *resultParams) {
          NSString *title = @"cancel success";
          if (resultParams == nil) {
              title = @"cancel cancel";
          }
          NSString *msg = @"";
          for (id key in [resultParams keyEnumerator]) {
              msg = [msg stringByAppendingString:key];
              msg = [msg stringByAppendingString:@"="];
              msg =
                  [msg stringByAppendingString:[resultParams valueForKey:key]];
              msg = [msg stringByAppendingString:@"\n"];
          }
          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:title
                               message:msg
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }
        onFailure:^(NSError *error) {
          UIAlertController *alertController = [UIAlertController
              alertControllerWithTitle:@"cancel failure"
                               message:[error localizedDescription]
                        preferredStyle:UIAlertControllerStyleAlert];
          [alertController
              addAction:[UIAlertAction actionWithTitle:@"OK"
                                                 style:UIAlertActionStyleDefault
                                               handler:nil]];
          [self presentViewController:alertController
                             animated:YES
                           completion:nil];
        }];
}

@end
